
[![Build Status](https://app.travis-ci.com/devsim/symdiff.svg?branch=main)](https://app.travis-ci.com/devsim/symdiff)
[![Build status](https://ci.appveyor.com/api/projects/status/github/devsim/symdiff?branch=main&svg=true)](https://ci.appveyor.com/project/devsim/symdiff)

# SYMDIFF

**SYMDIFF** is a tool for symbolic differentiation.  The source code is provided by Devsim LLC ([http://www.devsim.com](http://www.devsim.com)).
It is licensed under the [Apache 2.0 License](http://www.apache.org/licenses/LICENSE-2.0.html), meaning it is available for use in your own software.

## Software Features:
* [Documentation](https://github.com/devsim/symdiff/blob/main/doc/symdiff.pdf?raw=true)
* Expression parser
* Symbolic differentiation of expressions with respect to arbitrary number of variables.
* User defined differentiation rules for arbitrary functions
* Common subexpression elimination for group of expressions
* Expression ordering to facilitate source code generation.
* **C++** library
* **Python** scripting interface
* **Tcl** scripting interface

Recent changes are available in [CHANGES.md](CHANGES.md).

Please see NOTICE and LICENSE files for copyright and license information.

Documentation available in doc/symdiff.pdf.

## Install

This software is available via ``pip`` from [https://pypi.org/project/symdiff/](https://pypi.org/project/symdiff/).

```
pip install symdiff
```

## Citing This Work:

Please see [CITATION.md](CITATION.md).  *Please do not cite this Github Repository as it will be moving in the future.*

